 //////////////////////////////////////////////////////////////////////////////
//
// Syntax Highlighter, v1.0. Copyright  1998 Midnight Beach, all rights
// reserved. Reads C++ and Pascal source from the clipboard, writes it back
// syntax highlighted in HTML and RTF. Feel free to use the executable however
// you like, without any royalties or licensing. Please do NOT redistribute
// the executable, though - I would like the sole source to stay
// "http://www.midnightbeach.com/ftp_page/SyntaxHighlighter.html". Similarly,
// feel free to modify the source as you wish, but please do not redistribute
// the original source or any changes which you make. Questions and/or comments
// to jon@midnightbeach.com
//

//---------------------------------------------------------------------------
#ifndef ConvertH
#define ConvertH

#include <functional>

#include "Formats.h"
#include "utilities.h"

enum InputLanguages {Cpp, ObjectPascal};
#define NLanguages (ObjectPascal + 1)

enum OutputFormats  {HTML, RTF};
#define NFormats (RTF + 1)

typedef const char* SourceData;

// Immediate rendering
// (All of these fns should work fine with CR, LF, CR-LF, or LF-CR linebreaks)

HGLOBAL CppToHtml(SourceData Source);
HGLOBAL DelphiToHtml(SourceData Source);

HGLOBAL CppToRtf(SourceData Source);
HGLOBAL DelphiToRtf(SourceData Source);

HGLOBAL Highlight( OutputFormats Output,
                   SourceData Source,
                   InputLanguages Language);

void BothFormats( HGLOBAL& HTML, HGLOBAL& RTF,
                  SourceData Source, InputLanguages Language);

// Delayed rendering

void DiscardParseData();
void Parse(SourceData Source, InputLanguages Language);
HGLOBAL RenderToHtml();
HGLOBAL RenderToRTF();

//---------------------------------------------------------------------------
#endif

