 //////////////////////////////////////////////////////////////////////////////
//
// Syntax Highlighter, v1.0. Copyright  1998 Midnight Beach, all rights
// reserved. Reads C++ and Pascal source from the clipboard, writes it back
// syntax highlighted in HTML and RTF. Feel free to use the executable however
// you like, without any royalties or licensing. Please do NOT redistribute
// the executable, though - I would like the sole source to stay
// "http://www.midnightbeach.com/ftp_page/SyntaxHighlighter.html". Similarly,
// feel free to modify the source as you wish, but please do not redistribute
// the original source or any changes which you make. Questions and/or comments
// to jon@midnightbeach.com
//

//---------------------------------------------------------------------------
#ifndef CtrlPanelH
#define CtrlPanelH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>

#include <ShellAPI.h>
#include <Menus.hpp>

#include "Convert.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>;

//---------------------------------------------------------------------------

#define wm_TrayMsg (WM_USER + 0x1226) /* my birthday */

class TControlPanel : public TForm
{
__published:	// IDE-managed Components
        TPopupMenu *TrayMenu;
        TMenuItem *ConvertMnu;
        TMenuItem *N1;
        TMenuItem *CppMenu;
        TMenuItem *DelphiMnu;
        TMenuItem *N2;
        TMenuItem *OptionsMnu;
        TMenuItem *ExitMnu;
        TLabel *ElementLbl;
        TListBox *Element;
        TLabel *ColorLbl;
        TPanel *Panel1;
        TPanel *Panel2;
        TPanel *Panel3;
        TPanel *Panel4;
        TPanel *Panel5;
        TPanel *Panel6;
        TPanel *Panel7;
        TPanel *Panel8;
        TPanel *Panel9;
        TPanel *Panel10;
        TPanel *Panel11;
        TPanel *Panel12;
        TPanel *Panel13;
        TPanel *Panel14;
        TPanel *Panel15;
        TPanel *Panel16;
        TLabel *TextAttributesLbl;
        TCheckBox *Bold;
        TCheckBox *Italic;
        TCheckBox *Underline;
        TRadioButton *CppSource;
        TRadioButton *DelphiSource;
        TRichEdit *SourceWindow;
        TRadioButton *NoFeedback;
        TRadioButton *Beep;
        TRadioButton *ShowFormattedText;
        TPanel *FormattedTextOptionsPnl;
        TRadioButton *ForNSeconds;
        TRadioButton *UntilUserClosesIt;
        TEdit *ShowTimeEdit;
        TUpDown *ShowTime;
        TLabel *SecondsLbl;
        TMenuItem *AboutMnu;
        TMenuItem *N3;
        TPanel *SrcBtnPnl;
        TPanel *FeedbackBtnsPnl;
        TImage *BusyIcon;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall CppMenuClick(TObject *Sender);
        void __fastcall DelphiMnuClick(TObject *Sender);
        void __fastcall OptionsMnuClick(TObject *Sender);
        void __fastcall ExitMnuClick(TObject *Sender);
        void __fastcall ConvertMnuClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall ElementClick(TObject *Sender);
        void __fastcall SourceWindowSelectionChange(TObject *Sender);
        void __fastcall ColorPanelClick(TObject *Sender);
        void __fastcall BoldClick(TObject *Sender);
        void __fastcall ItalicClick(TObject *Sender);
        void __fastcall UnderlineClick(TObject *Sender);
        void __fastcall FeedbackClick(TObject *Sender);
        void __fastcall SetShowTimeWidgets(TObject *Sender);
        void __fastcall ShowTimeChanging(TObject *Sender,
      bool &AllowChange);
        void __fastcall SampleSourceSelect(TObject *Sender);
        void __fastcall AboutMnuClick(TObject *Sender);
private:	// User declarations
  // registry
  void LoadPreferences();
  void SavePreferences();

  // conversion code & values
  unsigned int RtfOnClipboard;

  InputLanguages fLanguage;
  void SetLanguage(InputLanguages Value);
  __property InputLanguages Language = {read = fLanguage, write = SetLanguage};
  void SetIcon(TIcon* Icon);

  // options editing code & values
  TPanel*    ColorPanel[16];
  TokenTypes CurrentElement;
  bool       Shutdown;
  bool       Setup;
  bool       ValidSource;

  void SetElement(int N);
  int ColorPanelIndex(TColor Color);
  void ShowSampleCode();
  void UpdateSampleCode();
  void SetPopupEnables();

protected:
    void __fastcall wmTrayMsg(TMessage& Message);

    void __fastcall wmRenderFormat(TMessage& Message);
    void __fastcall wmRenderAllFormats(TMessage& Message);
    void __fastcall wmDestroyClipboard(TMessage& Message);

    BEGIN_MESSAGE_MAP
      MESSAGE_HANDLER(wm_TrayMsg,          TMessage, wmTrayMsg)

      MESSAGE_HANDLER(WM_RENDERFORMAT,     TMessage, wmRenderFormat)
      MESSAGE_HANDLER(WM_RENDERALLFORMATS, TMessage, wmRenderAllFormats)
      MESSAGE_HANDLER(WM_DESTROYCLIPBOARD, TMessage, wmDestroyClipboard)
    END_MESSAGE_MAP(TForm)

public:		// User declarations
        __fastcall TControlPanel(TComponent* Owner);

};
//---------------------------------------------------------------------------
extern PACKAGE TControlPanel *ControlPanel;
//---------------------------------------------------------------------------
#endif

