 //////////////////////////////////////////////////////////////////////////////
//
// Syntax Highlighter, v1.0. Copyright  1998 Midnight Beach, all rights
// reserved. Reads C++ and Pascal source from the clipboard, writes it back
// syntax highlighted in HTML and RTF. Feel free to use the executable however
// you like, without any royalties or licensing. Please do NOT redistribute
// the executable, though - I would like the sole source to stay
// "http://www.midnightbeach.com/ftp_page/SyntaxHighlighter.html". Similarly,
// feel free to modify the source as you wish, but please do not redistribute
// the original source or any changes which you make. Questions and/or comments
// to jon@midnightbeach.com
//

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "PopupForm.h"
#include <algorithm>

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPopup *Popup;
//---------------------------------------------------------------------------
__fastcall TPopup::TPopup(TComponent* Owner)
        : TForm(Owner)
{
}

void TPopup::ShowHighlitSource(unsigned int Duration)
{
  TWaitCursor Hourglass; // sets cursor to hourglass

  SourceWindow->Clear();
  Show();
  bool WasReadOnly = SourceWindow->ReadOnly;
  SourceWindow->ReadOnly = false;
//  SourceWindow->SelectAll();
  SourceWindow->PasteFromClipboard();
  SourceWindow->ReadOnly = WasReadOnly;
  SourceWindow->SelStart = 0;
  SendMessage(SourceWindow->Handle, EM_SCROLLCARET, 0, 0);

  if (Duration != INFINITE) {
    Timer->Interval = Duration * 1000;
    Timer->Enabled  = true;
  }
} // TPopup::ShowHighlitSource

void __fastcall TPopup::TimerTimer(TObject *Sender)
{
  Close();
} // TPopup::TimerTimer

void __fastcall TPopup::FormClose(TObject *Sender, TCloseAction &Action)
{
  Timer->Enabled = false;
} // TPopup::FormClose

void __fastcall TPopup::FormCreate(TObject *Sender)
{
  StartHeight = ClientHeight;
  StartWidth  = ClientWidth;
} // TPopup::FormCreate

void __fastcall TPopup::SourceWindowResizeRequest(TObject *Sender,
      TRect &Rect)
{
  int LineCount = 0;
  string Text(SourceWindow->Lines->Text.c_str());
  std::count(Text.begin(), Text.end(), '\r', LineCount);

  ClientWidth  = max(StartWidth, Rect.Right);
  ClientHeight = max(StartHeight, Rect.Bottom);
} // TPopup::SourceWindowResizeRequest

//---------------------------------------------------------------------------

